// Package imports:
import 'package:zego_uikit/zego_uikit.dart';

/// You can listen to events that you are interested in here.
class ZegoUIKitPrebuiltLiveStreamingEvents {
  ZegoUIKitPrebuiltLiveStreamingHostEvents hostEvents;
  ZegoUIKitPrebuiltLiveStreamingAudienceEvents audienceEvents =
      ZegoUIKitPrebuiltLiveStreamingAudienceEvents();

  /// co-host updated
  Function(List<ZegoUIKitUser> coHosts)? onCoHostsUpdated;

  ZegoUIKitPrebuiltLiveStreamingEvents({
    this.onCoHostsUpdated,
    ZegoUIKitPrebuiltLiveStreamingHostEvents? hostEvents,
    ZegoUIKitPrebuiltLiveStreamingAudienceEvents? audienceEvents,
  })  : hostEvents = hostEvents ?? ZegoUIKitPrebuiltLiveStreamingHostEvents(),
        audienceEvents =
            audienceEvents ?? ZegoUIKitPrebuiltLiveStreamingAudienceEvents();
}

class ZegoUIKitPrebuiltLiveStreamingHostEvents {
  /// receive a request that audience request to become a co-host
  Function(ZegoUIKitUser audience)? onCoHostRequestReceived;

  /// cancelled their co-host request.
  Function(ZegoUIKitUser audience)? onCoHostRequestCanceled;

  /// co-host request has timed out.
  Function(ZegoUIKitUser audience)? onCoHostRequestTimeout;

  /// accept co-host request.
  Function()? onActionAcceptCoHostRequest;

  /// refuse co-host request.
  Function()? onActionRefuseCoHostRequest;

  /// sent invitation to become a co-host to the audience.
  Function(ZegoUIKitUser audience)? onCoHostInvitationSent;

  /// co-host invitation has timed out.
  Function(ZegoUIKitUser audience)? onCoHostInvitationTimeout;

  /// audience accepted to a co-host request from host
  void Function(ZegoUIKitUser audience)? onCoHostInvitationAccepted;

  /// audience refused to a co-host request from host
  void Function(ZegoUIKitUser audience)? onCoHostInvitationRefused;

  ZegoUIKitPrebuiltLiveStreamingHostEvents({
    this.onCoHostRequestReceived,
    this.onCoHostRequestCanceled,
    this.onCoHostRequestTimeout,
    this.onActionAcceptCoHostRequest,
    this.onActionRefuseCoHostRequest,
    this.onCoHostInvitationSent,
    this.onCoHostInvitationTimeout,
    this.onCoHostInvitationAccepted,
    this.onCoHostInvitationRefused,
  });
}

class ZegoUIKitPrebuiltLiveStreamingAudienceEvents {
  /// requested to become a co-host to the host.
  Function()? onCoHostRequestSent;

  /// cancelled co-host request.
  Function()? onActionCancelCoHostRequest;

  /// co-host request has timed out.
  Function()? onCoHostRequestTimeout;

  /// host accept co-host request.
  Function()? onCoHostRequestAccepted;

  /// host refuse co-host request.
  Function()? onCoHostRequestRefused;

  /// received a co-host invitation from the host.
  void Function(ZegoUIKitUser host)? onCoHostInvitationReceived;

  /// co-host invitation has timed out.
  Function()? onCoHostInvitationTimeout;

  /// refuse co-host invitation from the host.
  Function()? onActionAcceptCoHostInvitation;

  /// refuse co-host invitation from the host.
  Function()? onActionRefuseCoHostInvitation;

  ZegoUIKitPrebuiltLiveStreamingAudienceEvents({
    this.onCoHostRequestSent,
    this.onActionCancelCoHostRequest,
    this.onCoHostRequestTimeout,
    this.onCoHostRequestAccepted,
    this.onCoHostRequestRefused,
    this.onCoHostInvitationReceived,
    this.onCoHostInvitationTimeout,
    this.onActionAcceptCoHostInvitation,
    this.onActionRefuseCoHostInvitation,
  });
}
